(* tests for IsacKnowledge/Diff_App
   author Walther Neuper 000301
   (c) due to copyright terms

   use"../smltest/IsacKnowledge/diffapp.sml";
   use"diffapp.sml";
*)

"Contents----------------------------------------------";
"              Specify_Problem (by_i_models)       ";
"              test specify, fmz <> []                  ";
"              test specify, fmz = []                  ";
"          problemtypes + formalizations               ";
"-------------------- ctree of {(a,b). is-max ... ----------------";
"--------- me .. scripts for maximum-example ---------------------";
"--------- autoCalc .. scripts for maximum-example ---------------";

"--------------------- 30.4.03: maximum .. rewrite_set_ prog_expr ---------";
"---------------------- 1.5.03: Make_fun_by_explicit ---------------------";
"---------------------- 2.5.03: Make_fun_by_new_variable -----------------";





" #################################################### ";
"          problemtypes + formalizations               ";
" #################################################### ";
" -------------- [maximum_of,function] --------------- ";
val pbt = 
    ["fixedValues f_ix", "maximum m_m", "valuesFor v_s", "relations r_s"];
(*=== inhibit exn 110722=============================================================
map (the o (parseold thy)) pbt;
=== inhibit exn 110722=============================================================*)
val fmz =
    ["fixedValues [r=Arbfix]", "maximum A",
     "valuesFor [a,b]",
     "relations [A=a*b, (a/2) \<up> 2 + (b/2) \<up> 2 = r \<up> 2]",
     "relations [A=a*b, (a/2) \<up> 2 + (b/2) \<up> 2 = r \<up> 2]",
     "relations [A=a*b, a/2=r*sin alpha, b/2=r*cos (alpha::real)]",

     "boundVariable a", "boundVariable b", "boundVariable alpha",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= pi}",
     "errorBound (eps=(0::real))"];
(*=== inhibit exn 110722=============================================================
map (the o (parseold thy)) fmz;
" -------------- [make,function] -------------- ";
=== inhibit exn 110722=============================================================*)
val pbt = 
    ["functionOf f_f", "boundVariable v_v", "equalities eqs",
     "functionTerm f_0_0"];
(*=== inhibit exn 110722=============================================================
map (the o (parseold thy)) pbt;
val fmz12 =
    ["functionOf A", "boundVariable a", "boundVariable b",
     "equalities [A=a*b, (a/2) \<up> 2 + (b/2) \<up> 2 = r \<up> 2]",
     (*28.11.00: "functionTerm (A_0=Undef)"*)"functionTerm (Undef)"];
map (the o (parseold thy)) fmz12;
val fmz3 =
    ["functionOf A", "boundVariable a", "boundVariable b",
     "equalities [A=a*b, a/2=r*sin alpha, b/2=r*cos alpha]",
     (*28.11.00: "functionTerm (A_0=Undef)"*)"functionTerm (Undef)"];
map (the o (parseold thy)) fmz3;
" --------- [univar,equation] --------- ";
val pbt = 
    ["equality e_e", "solveFor v_v", "solutions v_i_i"];
map (the o (parseold thy)) pbt;
val fmz =
    ["equality ((a/2) \<up> 2 + (b/2) \<up> 2 = r \<up> 2)",
     "solveFor b", "solutions b_i"];
map (the o (parseold thy)) fmz;
" ---- [on_interval,maximum_of,function] ---- ";
val pbt = 
    ["functionTerm t_t", "boundVariable v_v", "interval itv_v",
     "errorBound err_r", "maxArgument v_0"];
map (the o (parseold thy)) pbt;
val fmz12 =
    [(*28.11.00: "functionTerm (A_0 = a*sqrt(#4*r \<up> #2 - a \<up> #2))",*)
     "functionTerm (a*sqrt(4*r \<up> 2 - a \<up> 2))",
     (*28.11.00: "functionTerm (A_0 = b*sqrt(#4*r \<up> #2 - b \<up> #2))",*)
     "functionTerm (b*sqrt(4*r \<up> 2 - b \<up> 2))",
     "boundVariable a", "boundVariable b",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "errorBound (eps=0)", "maxArgument (a_0=Undef)"];
map (the o (parseold thy)) fmz12;
val fmz3 =
    [(*28.11.00: "functionTerm (A_0 = (#2*r*sin alpha)*(#2*r*cos alpha))",*)
     "functionTerm ((2*r*sin alpha)*(2*r*cos alpha))",
     "boundVariable alpha",
     "interval {x::real. 0 <= x & x <= pi}",
     "errorBound (eps=0)", "maxArgument (a_0=Undef)"];
map (the o (parseold thy)) fmz3;
" --------- [derivative_of,function] --------- ";
val pbt = 
    ["functionTerm f_f", "boundVariable v_v", "derivative f_f'"];
map (the o (parseold thy)) pbt;
val fmz =
    [(*28.11.00: "functionTerm (A_0=a*#2*sqrt r \<up> #2 - (a//#2) \<up> #2)",*)
     "functionTerm (a*2*sqrt r \<up> 2 - (a/2) \<up> 2)",
     "boundVariable a",
     (*28.11.00: "derivative (A_0'=Undef)"*)"derivative (Undef)"];
map (the o (parseold thy)) fmz;
" --------- [find_values,tool] --------- ";
val pbt = 
    ["maxArgument ma_a", "functionTerm f_f", "boundVariable v_v",
     "valuesFor vls_s", "additionalRels r_s"];
map (the o (parseold thy)) pbt;
val fmz1 =
    ["maxArgument (a_0=(srqt 2)*r)",
     (*28.11.00: "functionTerm (A_0=a*#2*sqrt r \<up> #2 - (a//#2) \<up> #2)",*)
     "functionTerm (a*2*sqrt r \<up> 2 - (a/2) \<up> 2)",
     "boundVariable a",
     "valuesFor [a,b]", "maximum A",
     "additionalRels [(a/2) \<up> 2 + (b/2) \<up> 2 = r \<up> 2]"];
map (the o (parseold thy)) fmz1;

=== inhibit exn 110722=============================================================*)


"-------------------- ctree of {(a,b). is-max ... --------------------------";
"-------------------- ctree of {(a,b). is-max ... --------------------------";
"-------------------- ctree of {(a,b). is-max ... --------------------------";

(* --vvv-- ausgeliehen von test-root-equ/sml *)
val loc = Istate.empty;
val (dI',pI',mI') =
  ("Program",["sqroot-test", "univariate", "equation"],
   ["Program", "squ-equ-test2"]);
val fmz = ["equality (sqrt(9+4*x)=sqrt x + sqrt(5+x))",
	   "solveFor x", "errorBound (eps=0)",
	   "solutions L"];
(*
val (mI,m) = ("Init_Proof",Init_Proof (fmz, (dI',pI',mI')));
val ((p,p_),_,_,_,_,(_,pt,_)) = Test_Code.init_calc @{context} [fmz, (dI',pI',mI')))];
 -- \<up> -- ausgeliehen von test-root-equ/sml *)
(*-------------- 9.6.03 --- cappend_ ... term -------irreparabler test
val (pt,_) = 
  cappend_problem EmptyPtree [] loc ([],(dI',pI',mI'), .....);
val pos = (lev_on o lev_dn) [];
(* val pos = ([1]) *)
val (pt,_) = cappend_parent pt pos loc "{(a,b). is-max ..." 
    Empty_Tac TransitiveB;
val pos = (lev_on o lev_dn) pos;
(*val pos = ([1,1])*)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). is-max ..." 
    Empty_Tac ("[1,1]:{(a,b). is-extremum ...",[]) Complete;
val pos = lev_on pos;
(*val pos = ([1,2])*)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). is-extremum ..." 
    Empty_Tac ("[1,2]:{(a,b). f_x(a,b) ...",[]) Complete;
val pos = lev_up pos;
(*val pos = ([1])*)
val (pt,_) = append_result pt pos Istate.empty ("[1#]:{(a,b). f_x(a,b) ...",[])
    Complete;

val pos = lev_on pos;
(*val pos = ([2]) *)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). f_x(a,b) ..." 
    Empty_Tac ("[2]:{(a,b). f_x & f_xx &...",[]) Complete;
val pos = lev_on pos;
(*al pos = [3] : pos*)
val (pt,_) = cappend_parent pt pos loc "{(a,b). f_x & f_xx &..." 
    Empty_Tac TransitiveB;
val pos = (lev_on o lev_dn) pos;
(*pos = ([3,1]) *)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). f_x & f_xx & ..." 
    Empty_Tac ("[3,1]:{(a,b). f_x & f_xx } cup ...",[]) Complete;
val pos = lev_on pos;
(*pos = ([3,2]) *)
val (pt,_) = cappend_atomic pt pos loc "{(a,b). f_x & f_xx } cup.."
    Empty_Tac ("[3,2]:{(a,b). f_x ..} cup ...",[]) Complete;

val pos = lev_up pos;
(*pos = ([3]) *)
val (pt,_) = append_result pt pos Istate.empty ("[3#]:{(a,b). f_x ..} cup..",[])
    Complete;
val pos = lev_on pos;
(*val pos = [4] : pos *)
val (pt,_) = cappend_parent pt pos loc "{(a,b). f_x ..} cup ..." 
    Empty_Tac IntersectB;
val pos = (lev_on o lev_dn) pos;
(*val pos = ([4,1]) *)
val (pt,_) = cappend_parent pt pos loc "set_1 = ..." 
    Empty_Tac SequenceB;


val pos = (lev_on o lev_dn) pos;
(*val pos = ([4,1,1]) *)
val (pt,_) = cappend_parent(*pbl*) pt pos loc"f_x = d/dx x \<up> 3 ..."
    Empty_Tac TransitiveB;
val pos = (lev_on o lev_dn) pos;
(*val pos = ([4,1,1,1]) *)
val (pt,_) = cappend_parent pt pos loc "d/dx x \<up> 3 ..." 
    Empty_Tac TransitiveB;
val pos = (lev_on o lev_dn) pos;
(*val pos = ([4,1,1,1,1]) *)
val (pt,_) = cappend_atomic pt pos loc "d/dx x \<up> 3 ..." 
    Empty_Tac ("[4,1,1,1,1]:3x \<up> 2 + d/dx ...",[]) Complete;
val pos = lev_on pos;
(*val pos = ([4,1,1,1,2]) *)
val (pt,_) = cappend_atomic pt pos loc "3x \<up> 2 + d/dx ..." 
    Empty_Tac ("[4,1,1,1,2]:3x \<up> 2 + 0 + d/dx ...",[]) Complete;
val pos = lev_on pos;
(*pos = ([4,1,1,1,3]) *)
val (pt,_) = cappend_atomic pt pos loc "3x \<up> 2 + 0 + d/dx ..." 
    Empty_Tac ("[4,1,1,1,3]:3x \<up> 2 + 0 -3 ...",[]) Complete;
"--- 1 ---";
val pos = lev_up pos;
(*pos = ([4,1,1,1]) *)
val (pt,_) = append_result pt pos Istate.empty ("[4,1,1,1#]:3x \<up> 2 -3.",[])Complete;
"--- 2 ---";
val pos = lev_up pos;
(*val pos = ([4,1,1]) *)
val (pt,_) = append_result pt pos Istate.empty ("[4,1,1#]:found 3x \<up> 2 -3 ...",[])
    Complete;
"--- 3 ---";
val pos = lev_on pos;
(*val pos = ([4,1,2]+) *)
val (pt,_) = cappend_parent(*pbl*) pt pos loc "f_y = d/dy x \<up> 3 ..."
    Empty_Tac TransitiveB;
"--- 4 ---";
writeln (pr_ctree ctxt pr_short pt);

(*
.    ----- pblobj -----
1.   {(a,b). is-max ...
1.1.   {(a,b). is-max ...
1.2.   {(a,b). is-extremum ...
2.   {(a,b). f_x(a,b) ...
3.   {(a,b). f_x & f_xx &...
3.1.   {(a,b). f_x & f_xx & ...
3.2.   {(a,b). f_x & f_xx } cup..
4.   {(a,b). f_x ..} cup ...
4.1.   set_1 = ...
4.1.1.   f_x = d/dx x \<up> 3 ...
4.1.1.1.   d/dx x \<up> 3 ...
4.1.1.1.1.   d/dx x \<up> 3 ...
4.1.1.1.2.   3x \<up> 2 + d/dx ...
4.1.1.1.3.   3x \<up> 2 + 0 + d/dx ...
4.1.2.   f_y = d/dy x \<up> 3 ...
  
 use"test-max-surf1.sml";
   *)
-------------- 9.6.03 --- cappend_ ... term -------irreparabler test---*)


"--------- me .. scripts for maximum-example ---------------------";
"--------- me .. scripts for maximum-example ---------------------";
"--------- me .. scripts for maximum-example ---------------------";

val fmz =
    ["fixedValues [r=Arbfix]", "maximum A",
     "valuesFor [a,b]",
     "relations [A=a*b, (a/2) \<up> 2 + (b/2) \<up> 2 = r \<up> 2]",
     "relations [A=a*b, (a/2) \<up> 2 + (b/2) \<up> 2 = r \<up> 2]",
     "relations [A=a*b, a/2=r*sin alpha, b/2=r*cos (alpha::real)]",

     "boundVariable a", "boundVariable b", "boundVariable alpha",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= pi}",
     "errorBound (eps=(0::real))"];
val (dI',pI',mI') =
  ("Diff_App",["maximum_of", "function"],
   ["Diff_App", "max_by_calculus"]);

val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))];
(*=== inhibit exn 110722=============================================================
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = (me nxt p c pt) handle e => OldGoals.print_exn e;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Specify_Method ["Diff_App", "max_by_calculus"]) => ()
	  | _ => error "diffapp.sml: max-exp me, nxt = Specify_Method";

val oris = fst3 (get_obj g_origin pt (fst p)); writeln(O_Model.to_string oris);
val pits = get_obj g_pbl pt (fst p); writeln(I_Model.to_string ctxt pits);

val (p,_,f,nxt,_,pt) = me nxt p c pt;
val mits = get_obj g_met pt (fst p); writeln(I_Model.to_string ctxt mits);
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_,Apply_Method ["Diff_App", "max_by_calculus"] ) => ()
	  | _ => error "diffapp.sml: max-exp me, nxt = Apply_Method";
val (p,_,f,nxt,_,pt) = me nxt p c pt;
=== inhibit exn 110722=============================================================*)

(*since 0508 Apply_Method does the 1st step, if NONE implicit_take -------------
(*val nxt = ("Subproblem",Subproblem ("Diff_App",["make", "function"]))*)
val (p,_,f,nxt,_,pt) = (me nxt p c pt) handle e => print_exn_G e;
(*val nxt = ("Refine_Tacitly",Refine_Tacitly ["make", "function"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = ("Model_Problem",Model_Problem ["by_explicit", "make", "function"])*)
----------------------------------------------------------------------------*)
case nxt of (Model_Problem(*["by_explicit", "make", "function"]*)) => ()
	  | _ => error "diffapp.sml: max-exp me, nxt = Model_Problem";

(*=== inhibit exn 110722=============================================================
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
=== inhibit exn 110722=============================================================*)

val oris = fst3 (get_obj g_origin pt (fst p));writeln(O_Model.to_string @{context} oris);
val pits = get_obj g_pbl pt (fst p);writeln(I_Model.to_string ctxt pits);

(*=== inhibit exn 110722=============================================================
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["Diff_App", "make_fun_by_explicit"]) => ()
	  | _ => error "diffapp.sml: max-exp Apply_Method ([1], Met) ";
=== inhibit exn 110722=============================================================*)

(*----since WN050901 (ie. corr. mathengine#nxt_specify_ ..Specify.find_next_step' Pbl->p_
we get at ...
val (p,_,f,nxt,_,pt) = me nxt p c pt;
...
### associate: Not_Associated m= Subproblem'  ,
 stac= Substitute
 [(b, (rhs o hd)
       (Subproblem (thy, [normalise, polynomial, univariate, equation])))]
 (hd (filterVar A [A = a * b, (a / 2) \<up> 2 + (b / 2) \<up> 2 = r \<up> 2]))
*** tac_from_prog TODO: no match for Substitute
***  [(b, (rhs o hd)
***        (Subproblem (thy, [normalise, polynomial, univariate, equation])))]
***  (hd (filterVar A [A = a * b, (a / 2) \<up> 2 + (b / 2) \<up> 2 = r \<up> 2]))
Exception- ERROR raised

############################################################################
# presumerably didnt work before either, but not detected due to Emtpy_Tac #
############################################################################

(*val nxt = Subproblem ("Diff_App",["univariate", "equation"]))   *)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = Refine_Tacitly ["univariate", "equation"])*)

val oris = fst3 (get_obj g_origin pt (fst p));writeln(O_Model.to_string oris);
val pits = get_obj g_pbl pt (fst p);writeln(I_Model.to_string ctxt pits);

val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val nxt = ("Apply_Method",Apply_Method ["PolyEq", "normalise_poly"])*)

val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val f = Form' (Test_Out.FormKF (~1,EdUndef,3,Nundef,"A = a * b"))*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*val f = Form' (Test_Out.FormKF (~1,EdUndef,4,Nundef,"[b = A / a]"))*)

------------------------------------------------------------------------*)

(*val f =
Error' (Error_ "Refine_Tacitly [\"univariate\",\"equation\"] not applicable")*)


(*----postponed.15.5.03 run scripts for maximum-example: univariate equation*)
(*=== inhibit exn 110722=============================================================

val (p,_,f,nxt,_,pt) = (me nxt p c pt) handle e => OldGoals.print_exn e; 
=== inhibit exn 110722=============================================================*)

val oris = fst3 (get_obj g_origin pt (fst p));writeln(O_Model.to_string @{context} oris);

val pits = get_obj g_pbl pt (fst p);writeln(I_Model.to_string ctxt pits);
val pits = get_obj g_pbl pt [];writeln(I_Model.to_string ctxt pits);

val mits = get_obj g_met pt (fst p);writeln(I_Model.to_string ctxt mits);
val mits = get_obj g_met pt [];writeln(I_Model.to_string ctxt mits);

(*=== inhibit exn 110722=============================================================
arguments_from_model ["Diff_App", "max_by_calculus"] mits;

val (p,_,f,nxt,_,pt) = me nxt p c pt;
=== inhibit exn 110722=============================================================*)


"--------- autoCalc .. scripts for maximum-example ---------------";
"--------- autoCalc .. scripts for maximum-example ---------------";
"--------- autoCalc .. scripts for maximum-example ---------------";
(*++++++++ see systest/inform.sml 'I_Model.complete' ++++++++*)
 States.reset ();
val fmz =
    ["fixedValues [r=Arbfix]", "maximum A",
     "valuesFor [a,b]",
     "relations [A=a*b, (a/2) \<up> 2 + (b/2) \<up> 2 = r \<up> 2]",
     "relations [A=a*b, (a/2) \<up> 2 + (b/2) \<up> 2 = r \<up> 2]",
     "relations [A=a*b, a/2=r*sin alpha, b/2=r*cos (alpha::real)]",

     "boundVariable a", "boundVariable b", "boundVariable alpha",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= 2*r}",
     "interval {x::real. 0 <= x & x <= pi}",
     "errorBound (eps=(0::real))"];
val (dI',pI',mI') =
  ("Diff_App",["maximum_of", "function"],
   ["Diff_App", "max_by_calculus"]);

 CalcTree @{context} [(fmz, (dI',pI',mI'))];
 Iterator 1; moveActiveRoot 1;
 autoCalculate 1 CompleteCalcHead;
 refFormula 1 (States.get_pos 1 1); 

 fetchProposedTactic 1;
(*autoCalculate 1 (Steps 1);
    broken in child of.1790e1073acc : eliminate "handle _ => ..." from Rewrite.rewrite
    this test is not up to date
    ERROR exception TERM raised (line 359 of "term.ML"): fastype_of: Bound B.0*)

 fetchProposedTactic 1;
(*autoCalculate 1 (Steps 1);
    broken in child of.1790e1073acc : eliminate "handle _ => ..." from Rewrite.rewrite
    this test is not up to date
    ERROR exception TERM raised (line 359 of "term.ML"): fastype_of: Bound B.0*)
 (*Subproblem on_interval maximum_of function*)
 autoCalculate 1 CompleteCalcHead;

 fetchProposedTactic 1;
 val ((pt,p),_) = States.get_calc 1;
 val mits = get_obj g_met pt (fst p);
 writeln (I_Model.to_string ctxt mits);
(*
 if I_Model.to_string ctxt mits = "[\n(1 ,[1] ,true ,#Given ,Cor functionEq (hd r_s) ,(t_, [hd r_s])),\n(2 ,[1] ,true ,#Given ,Cor boundVariable v_v ,(v_, [v_])),\n(3 ,[1] ,true ,#Given ,Cor interval itv_ ,(itv_, [itv_])),\n(4 ,[1] ,true ,#Find ,Cor maxArgument v__0 ,(v_0, [v__0]))]" then ()
 else error "diffapp.sml: diff.behav. in autoCalc .. scripts for max 1";
*)
 (*FIXME: the environments contain identifers, and NOT values ?!?!?*)
(* WN051209 while extending 'fun step' for initac, this became better ...
 if I_Model.to_string ctxt mits = "[\n(1 ,[1,2,3] ,true ,#Given ,Cor fixedValues [r = Arbfix] ,(f_ix, [[r = Arbfix]])),\n(2 ,[1,2,3] ,true ,#Find ,Cor maximum A ,(m_, [A])),\n(3 ,[1,2,3] ,true ,#Find ,Cor valuesFor [a, b] ,(v_s, [[a],[b]])),\n(4 ,[1,2] ,true ,#Relate ,Cor relations [A = a * b, (a / 2) \<up> 2 + (b / 2) \<up> 2 = r \<up> 2] ,(r_s, [[A = a * b],[(a / 2) \<up> 2 + (b / 2) \<up> 2 = r \<up> 2]])),\n(6 ,[1] ,true ,#undef ,Cor boundVariable a ,(v_, [a])),\n(9 ,[1,2] ,true ,#undef ,Cor interval {x. 0 <= x & x <= 2 * r} ,(itv_, [{x. 0 <= x & x <= 2 * r}])),\n(11 ,[1,2,3] ,true ,#undef ,Cor errorBound (eps = 0) ,(err_, [eps = 0]))]" then ()
 else error "diffapp.sml: diff.behav. in autoCalc .. scripts for max 1";
*)



"--------------------- 30.4.03: maximum .. rewrite_set_ prog_expr ---------";
"--------------------- 30.4.03: maximum .. rewrite_set_ prog_expr ---------";
"--------------------- 30.4.03: maximum .. rewrite_set_ prog_expr ---------";
ParseC.parse_test @{context}
  "Program Maximum_value(f_ix::bool list)(m_m::real) (r_s::bool list)\
   \      (v_v::real) (itv_v::real set) (err_r::bool) =          \ 
   \ (let e_e = (hd o (filterVar m_m)) r_s;              \
   \      t_t = (if 1 < length_h r_s                            \
   \           then (SubProblem (Reals_s,[make,function],[no_met])\
   \                     [REAL m_m, REAL v_v, BOOL_LIST r_s])\
   \           else (hd r_s));                                \
   \      (mx_x::real) = SubProblem (Reals_s,[on_interval,max_of,function], \
   \                                [Isac,maximum_on_interval])\
   \                               [BOOL t_t, REAL v_v, REAL_SET itv_v]\
   \ in ((SubProblem (Reals_s,[find_values,tool],[Isac,find_values])   \
   \      [REAL mx_x, REAL (Rhs t_t), REAL v_v, REAL m_m,     \
   \       BOOL_LIST (dropWhile (ident e_e) r_s)])::bool list))";

val f_ix = (ParseC.parse_test @{context} "f_ix::bool list", 
	    ParseC.parse_test @{context} "[r=Arbfix]");
val m_m   = (ParseC.parse_test @{context} "m_m::real", 
	    ParseC.parse_test @{context} "A");
val r_s  = (ParseC.parse_test @{context} "rs_s::bool list", 
	    ParseC.parse_test @{context} "[A = a*b, (a/2) \<up> 2 + (b/2) \<up> 2 = r \<up> 2]");
val v_v   = (ParseC.parse_test @{context} "v_v::real", 
	    ParseC.parse_test @{context} "b");
val itv_v = (ParseC.parse_test @{context} "itv_v::real set", 
	    ParseC.parse_test @{context} "{x::real. 0 <= x & x <= 2*r}");
val err_r = (ParseC.parse_test @{context} "err_r::bool", 
	    ParseC.parse_test @{context} "eps=0");
val env = [f_ix, m_m, r_s ,v_v, itv_v, err_r];

(*--- 1.line in script ---*)
val t = ParseC.parse_test @{context} "(hd o (filterVar m_m)) (r_s::bool list)";
val s = subst_atomic env t;
UnparseC.term @{context} s;
"(hd o filterVar A) [A = a * b, (a / 2) \<up> 2 + (b / 2) \<up> 2 = r \<up> 2]";
(*=== inhibit exn 110726=============================================================
val SOME (s',_) = rewrite_set_ thy false prog_expr s;
val s'' = UnparseC.term @{context} s';
if s''="A = a * b" then () else error "new behaviour with prog_expr 1.1.";
=== inhibit exn 110726=============================================================*)
val env = env @ [(ParseC.parse_test @{context} "e_e::bool",ParseC.parse_test @{context} "A = a * b")];

(*--- 2.line: condition alone ---*)
val t = ParseC.parse_test @{context} "1 < length_h (r_s::bool list)";
val s = subst_atomic env t;
UnparseC.term @{context} s;
"1 < length_h [A = a * b, (a / 2) \<up> 2 + (b / 2) \<up> 2 = r \<up> 2]";
(*=== inhibit exn 110726=============================================================
val SOME (s',_) = rewrite_set_ thy false prog_expr s;
val s'' = UnparseC.term @{context} s';
if s''=\<^const_name>\<open>True\<close> then () else error "new behaviour with prog_expr 1.2.";
=== inhibit exn 110726=============================================================*)

(*--- 2.line in script ---*)
val t = ParseC.parse_test @{context} 
	    "(if 1 < length_h r_s                            \
   \           then (SubProblem (Reals_s,[make,function],[no_met])\
   \                     [REAL m_m, REAL v_v, BOOL_LIST r_s])\
   \           else (hd r_s))";
val s = subst_atomic env t;
UnparseC.term @{context} s;
"if 1 < length_h [A = a * b, (a / 2) \<up> 2 + (b / 2) \<up> 2 = r \<up> 2]\
\then SubProblem (Reals_s, [make, function], [no_met])\
\      [REAL A, REAL b,\
\       BOOL_LIST [A = a * b, (a / 2) \<up> 2 + (b / 2) \<up> 2 = r \<up> 2]]\
\else hd [A = a * b, (a / 2) \<up> 2 + (b / 2) \<up> 2 = r \<up> 2]";
(*=== inhibit exn 110726=============================================================
val SOME (s',_) = rewrite_set_ thy false prog_expr s;
val s'' = UnparseC.term @{context} s';
if s'' = 
"SubProblem (Reals_s, [make, function], [no_met])\n\
\ [REAL A, REAL b,\n\
\  BOOL_LIST [A = a * b, (a / 2) \<up> 2 + (b / 2) \<up> 2 = r \<up> 2]]" then ()
else error "new behaviour with prog_expr 1.3.";
=== inhibit exn 110726=============================================================*)
val env = env @ [(ParseC.parse_test @{context} "t_t::bool",
		  ParseC.parse_test @{context} "A = (2*sqrt(r \<up> 2-(b/2) \<up> 2)) * b")];



"---------------------- 1.5.03: Make_fun_by_explicit ---------------------";
"---------------------- 1.5.03: Make_fun_by_explicit ---------------------";
"---------------------- 1.5.03: Make_fun_by_explicit ---------------------";
ParseC.parse_test @{context}
   "Program Make_fun_by_explicit (f_f::real) (v_v::real)         \
   \      (eqs::bool list) =                                 \
   \ (let h_h  = (hd o (filterVar f_f)) eqs;                   \
   \      e_1 = hd (dropWhile (ident h_h) eqs);               \
   \      v_s = dropWhile (ident f_f) (Vars h_h);                \
   \      v_1 = hd (dropWhile (ident v_v) v_s);                \
   \      (s_1::bool list)=(SubProblem(Reals_s,[univar,equation],[no_met])\
   \                          [BOOL e_1, REAL v_1])\
   \ in Substitute [(v_1 = (rhs o hd) s_1)] h_h)";
val f_f = (ParseC.parse_test @{context} "f_f::real", 
	  ParseC.parse_test @{context} "A");
val v_v = (ParseC.parse_test @{context} "v_v::real", 
	  ParseC.parse_test @{context} "b");
val eqs=(ParseC.parse_test @{context} "eqs::bool list", 
	  ParseC.parse_test @{context} "[A = a * b, (a / 2) \<up> 2 + (b / 2) \<up> 2 = r \<up> 2]");
val env = [f_f, v_v, eqs];

(*--- 1.line in script ---*)
val t = ParseC.parse_test @{context} "(hd o (filterVar v_v)) (eqs::bool list)";
val s = subst_atomic env t;
UnparseC.term @{context} s;
val t = ParseC.parse_test @{context} 
     "(hd o filterVar b) [A = a * b, (a / 2) \<up> 2 + (b / 2) \<up> 2 = r \<up> 2]";
val SOME (t',_) = rewrite_set_ ctxt false prog_expr t;
val s' = UnparseC.term @{context} t';
(*=== inhibit exn 110726=============================================================
if s' = "A = a * b" then () else error "new behaviour with prog_expr 2.1";
=== inhibit exn 110726=============================================================*)
val env = env @ [(ParseC.parse_test @{context} "h_h::bool", ParseC.parse_test @{context} s')];

(*--- 2.line in script ---*)
val t = ParseC.parse_test @{context} "hd (dropWhile (ident h_h) (eqs::bool list))";
val s = subst_atomic env t;
UnparseC.term @{context} s;
val t = ParseC.parse_test @{context} 
	    "hd (dropWhile (ident (A = a * b))\
	    \     [A = a * b, (a / 2) \<up> 2 + (b / 2) \<up> 2 = r \<up> 2])";
(*=== inhibit exn 110726=============================================================
mem_rls "dropWhile_Cons" prog_expr;
mem_rls "Prog_Expr.ident" prog_expr;
val SOME (t',_) = rewrite_set_ thy false prog_expr t;
val s' = UnparseC.term @{context} t';
if s' = "(a / 2) \<up> 2 + (b / 2) \<up> 2 = r \<up> 2" then () 
else error "new behaviour with prog_expr 2.2";
=== inhibit exn 110726=============================================================*)
val env = env @ [(ParseC.parse_test @{context} "e_1::bool", ParseC.parse_test @{context} s')];

(*--- 3.line in script ---*)
val t = ParseC.parse_test @{context} "dropWhile (ident f_f) (Vars (h_h::bool))";
val s = subst_atomic env t;
UnparseC.term @{context} s;
val t = ParseC.parse_test @{context} "dropWhile (ident A) (Vars (A = a * b))";
(*=== inhibit exn 110726=============================================================
val SOME (t',_) = rewrite_set_ thy false prog_expr t;
val s' = UnparseC.term @{context} t';
if s' = "[a, b]" then () else error "new behaviour with prog_expr 2.3";
=== inhibit exn 110726=============================================================*)
val env = env @ [(ParseC.parse_test @{context} "vs_s::real list", ParseC.parse_test @{context} s')];

(*--- 4.line in script ---*)
val t = ParseC.parse_test @{context} "hd (dropWhile (ident v_v) v_s)";
val s = subst_atomic env t;
UnparseC.term @{context} s;
val t = ParseC.parse_test @{context} "hd (dropWhile (ident b) [a, b])";
(*=== inhibit exn 110726=============================================================
val SOME (t',_) = rewrite_set_ thy false prog_expr t;
val s' = UnparseC.term @{context} t';
if s' = "a" then () else error "new behaviour with prog_expr 2.4.";
=== inhibit exn 110726=============================================================*)
val env = env @ [(ParseC.parse_test @{context} "v_1::real", ParseC.parse_test @{context} s')];

(*--- 5.line in script ---*)
val t = ParseC.parse_test @{context} "(SubProblem(Reals_s,[univar,equation],[no_met])\
		 \           [BOOL e_1, REAL v_1])";
val s = subst_atomic env t;
UnparseC.term @{context} s;
"SubProblem (Reals_s, [univar, equation], [no_met])\n\
\ [BOOL ((a / 2) \<up> 2 + (b / 2) \<up> 2 = r \<up> 2), REAL a]";
val env = env @ [(ParseC.parse_test @{context} "s_1::bool list", 
		  ParseC.parse_test @{context} "[a = 2 * sqrt (r \<up> 2 - (b/2) \<up> 2)]")];

(*--- 6.line in script ---*)
val t = ParseC.parse_test @{context} "Substitute [(v_1 = (rhs o hd) (s_1::bool list))] (h_h::bool)";
val s = subst_atomic env t;
UnparseC.term @{context} s;
val t = ParseC.parse_test @{context} 
"Substitute [(a = (rhs o hd) [a = 2 * sqrt (r \<up> 2 - (b / 2) \<up> 2)])]\n\
\ (A = a * b)";
(*=== inhibit exn 110726=============================================================
mem_rls "Prog_Expr.rhs" prog_expr;
val SOME (t',_) = rewrite_set_ thy false prog_expr t;
val s' = UnparseC.term @{context} t';
if s' = "Substitute [a = 2 * sqrt (r \<up> 2 - (b / 2) \<up> 2)] (A = a * b)" 
then () else error "new behaviour with prog_expr 2.6.";
=== inhibit exn 110726=============================================================*)


"---------------------- 2.5.03: Make_fun_by_new_variable -----------------";
"---------------------- 2.5.03: Make_fun_by_new_variable -----------------";
"---------------------- 2.5.03: Make_fun_by_new_variable -----------------";
ParseC.parse_test @{context}
  "Program Make_fun_by_new_variable (f_f::real) (v_v::real)     \
   \      (eqs::bool list) =                                 \
   \(let h_h = (hd o (filterVar f_f)) eqs;             \
   \     es_s = dropWhile (ident h_h) eqs;                    \
   \     v_s = dropWhile (ident f_f) (Vars h_h);                \
   \     v_1 = nth_h 1 v_s;                                   \
   \     v_2 = nth_h 2 v_s;                                   \
   \     e_1 = (hd o (filterVar v_1)) es_s;            \
   \     e_2 = (hd o (filterVar v_2)) es_s;            \
   \  (s_1::bool list) = (SubProblem (Reals_s,[univar,equation],[no_met])\
   \                    [BOOL e_1, REAL v_1]);\
   \  (s_2::bool list) = (SubProblem (Reals_s,[univar,equation],[no_met])\
   \                    [BOOL e_2, REAL v_2])\
   \in Substitute [(v_1 = (rhs o hd) s_1),(v_2 = (rhs o hd) s_2)] h_h)";
val f_ = (ParseC.parse_test @{context} "f_f::real", 
	  ParseC.parse_test @{context} "A");
val v_v = (ParseC.parse_test @{context} "v_v::real", 
	  ParseC.parse_test @{context} "alpha");
val eqs=(ParseC.parse_test @{context} "eqs::bool list", 
	  ParseC.parse_test @{context} "[A=a*b, a/2=r*sin alpha, b/2=r*cos (alpha::real)]");
val env = [f_f, v_v, eqs];

(*--- 1.line in script ---*)
val t = ParseC.parse_test @{context} "(hd o (filterVar (f_f::real))) (eqs::bool list)";
val s = subst_atomic env t;
UnparseC.term @{context} s;
val t = ParseC.parse_test @{context} 
"(hd o filterVar A) [A = a * b, a / 2 = r * sin alpha, b / 2 = r * cos alpha]";
val SOME (t',_) = rewrite_set_ ctxt false prog_expr t;
val s' = UnparseC.term @{context} t';
(*=== inhibit exn 110726=============================================================
if s' = "A = a * b" then() else error "new behaviour with prog_expr 3.1.";
val env = env @ [(ParseC.parse_test @{context} "h_h::bool", ParseC.parse_test @{context} s')];
=== inhibit exn 110726=============================================================*)

(*--- 2.line in script ---*)
val t = ParseC.parse_test @{context} "dropWhile (ident (h_h::bool)) (eqs::bool list)";
val s = subst_atomic env t;
UnparseC.term @{context} s;
val t = ParseC.parse_test @{context} 
"dropWhile (ident (A = a * b))\
\ [A = a * b, a / 2 = r * sin alpha, b / 2 = r * cos alpha]";
(*=== inhibit exn 110726=============================================================
val SOME (t',_) = rewrite_set_ thy false prog_expr t;
val s' = UnparseC.term @{context} t';
if s' = "[a / 2 = r * sin alpha, b / 2 = r * cos alpha]" 
then () else error "new behaviour with prog_expr 3.2.";
=== inhibit exn 110726=============================================================*)
val env = env @ [(ParseC.parse_test @{context} "es_s::bool list", ParseC.parse_test @{context} s')];

(*--- 3.line in script ---*)
val t = ParseC.parse_test @{context} "dropWhile (ident (f_f::real)) (Vars (h_h::bool))";
val s = subst_atomic env t;
UnparseC.term @{context} s;
val t = ParseC.parse_test @{context} "dropWhile (ident A) (Vars (A = a * b))";
(*=== inhibit exn 110726=============================================================
val SOME (t',_) = rewrite_set_ thy false prog_expr t;
val s' = UnparseC.term @{context} t';
if s' = "[a, b]" then () else error "new behaviour with prog_expr 3.3.";
=== inhibit exn 110726=============================================================*)
val env = env @ [(ParseC.parse_test @{context} "vs_s::real list", ParseC.parse_test @{context} s')];

(*--- 4.line in script ---*)
val t = ParseC.parse_test @{context} "nth_h 1 v_s";
val s = subst_atomic env t;
UnparseC.term @{context} s;
val t = ParseC.parse_test @{context} "nth_h 1 [a, b]";
(*=== inhibit exn 110726=============================================================
val SOME (t',_) = rewrite_set_ thy false prog_expr t;
val s' = UnparseC.term @{context} t';
if s' = "a" then () else error "new behaviour with prog_expr 3.4.";
=== inhibit exn 110726=============================================================*)
val env = env @ [(ParseC.parse_test @{context} "v_1", ParseC.parse_test @{context} s')];

(*--- 5.line in script ---*)
val t = ParseC.parse_test @{context} "nth_h 2 v_s";
val s = subst_atomic env t;
UnparseC.term @{context} s;
val t = ParseC.parse_test @{context} "nth_h 2 [a, b]";
(*=== inhibit exn 110726=============================================================
val SOME (t',_) = rewrite_set_ thy false prog_expr t;
val s' = UnparseC.term @{context} t';
if s' = "b" then () else error "new behaviour with prog_expr 3.5.";
=== inhibit exn 110726=============================================================*)
val env = env @ [(ParseC.parse_test @{context} "v_2", ParseC.parse_test @{context} s')];

(*--- 6.line in script ---*)
val t = ParseC.parse_test @{context} "(hd o (filterVar v_1)) (es_s::bool list)";
val s = subst_atomic env t;
UnparseC.term @{context} s;
val t = ParseC.parse_test @{context} 
	   "(hd o filterVar a) [a / 2 = r * sin alpha, b / 2 = r * cos alpha]";
val SOME (t',_) = rewrite_set_ ctxt false prog_expr t;
val s' = UnparseC.term @{context} t';
(*=== inhibit exn 110726=============================================================
if s' = "a / 2 = r * sin alpha" then () 
else error "new behaviour with prog_expr 3.6.";
=== inhibit exn 110726=============================================================*)
val e_1 = ParseC.parse_test @{context} "e_1::bool";
val env = env @ [(e_1, ParseC.parse_test @{context} s')];

(*--- 7.line in script ---*)
val t = ParseC.parse_test @{context} "(hd o (filterVar v_2)) (es_s::bool list)";
val s = subst_atomic env t;
UnparseC.term @{context} s;
val t = ParseC.parse_test @{context} 
	  "(hd o filterVar b) [a / 2 = r * sin alpha, b / 2 = r * cos alpha]";
val SOME (t',_) = rewrite_set_ ctxt false prog_expr t;
val s' = UnparseC.term @{context} t';
(*=== inhibit exn 110726=============================================================
if s' = "b / 2 = r * cos alpha" then () 
else error "new behaviour with prog_expr 3.7.";
=== inhibit exn 110726=============================================================*)
val env = env @ [(ParseC.parse_test @{context} "e_2::bool", ParseC.parse_test @{context} s')];

(*--- 8.line in script ---*)
val t = ParseC.parse_test @{context} "(SubProblem (Reals_s,[univar,equation],[no_met])\
		 \            [BOOL e_1, REAL v_1])";
val s = subst_atomic env t;
UnparseC.term @{context} s;
"SubProblem (Reals_s, [univar, equation], [no_met])\
	    \ [BOOL (a / 2 = r * sin alpha), REAL a]";
val s_1 = ParseC.parse_test @{context} "[a = 2*r*sin alpha]";
val env = env @ [(ParseC.parse_test @{context} "s_1::bool list", s_1)];

(*--- 9.line in script ---*)
val t = ParseC.parse_test @{context} "(SubProblem (Reals_s,[univar,equation],[no_met])\
   \                    [BOOL e_2, REAL v_2])";
val s = subst_atomic env t;
UnparseC.term @{context} s;
"SubProblem (Reals_s, [univar, equation], [no_met])\
	    \ [BOOL (b / 2 = r * cos alpha), REAL b]";
val s_2 = ParseC.parse_test @{context} "[b = 2*r*cos alpha]";
val env = env @ [(ParseC.parse_test @{context} "s_2::bool list", s_2)];

(*--- 10.line in script ---*)
val t = ParseC.parse_test @{context} 
"Substitute [(v_1 = (rhs o hd) s_1),(v_2 = (rhs o hd) s_2)] (h_h::bool)";
val s = subst_atomic env t;
UnparseC.term @{context} s;
"Substitute\n [(a = (rhs o hd) [a = 2 * r * sin alpha]),\
\              (b = (rhs o hd) [b = 2 * r * cos alpha])] (A = a * b)";
val SOME (s',_) = rewrite_set_ ctxt false prog_expr s;
val s'' = UnparseC.term @{context} s';
(*=== inhibit exn 110726=============================================================
if s'' = 
"Substitute [a = 2 * r * sin alpha, b = 2 * r * cos alpha] (A = a * b)"
then () else error "new behaviour with prog_expr 3.10.";
===== inhibit exn 110722===========================================================*)

